/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.smartapplication.vcdevice.service;

import org.springblade.core.tool.api.R;
import org.springblade.smartapplication.vcdevice.entity.VideoCloudDevice;
import org.springblade.smartapplication.vcdevice.vo.VideoCloudDeviceVO;
import org.springblade.core.mp.base.BaseService;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 *  服务类
 *
 * @author BladeX
 * @since 2020-11-12
 */
public interface IVideoCloudDeviceService extends BaseService<VideoCloudDevice> {

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param videoCloudDevice
	 * @return
	 */
	IPage<VideoCloudDeviceVO> selectVideoCloudDevicePage(IPage<VideoCloudDeviceVO> page, VideoCloudDeviceVO videoCloudDevice);

	List<VideoCloudDevice> likeByResidentialName(String residentialName);

	List<String> getAllVCDeviceAccountName();

	VideoCloudDevice getByOldId(String oldId);

    R syncByAccount(String accountName);

	R syncByAccountV3(String accountName);

    List<VideoCloudDevice> listByAccountName(String accountName);

	R syncByDevice(String accountName, String deviceNum);

	R syncByDeviceV3(String accountName, String deviceId);

	R<String> getVideoUrlV2(String accountName, String deviceNum, String networkType);

	R<String> getVideoUrlV3(String accountName, String deviceNum, String networkType);

	VideoCloudDevice getByDeviceNum(String deviceNum);

	R getVideoUrlBatch(List<Long> idList);

	R syncByDeviceBatch(List<Long> idList);

	R zlmPlayProxy(String deviceNum);

	R zlmStopProxy(String deviceNum);

	R zlmPlayFFmpeg(String deviceNum);

	R zlmStopFFmpeg(String deviceNum);
}
